Package org.silverpeas.components.kmelia.importexport

## Class KmeliaImportExport

- java.lang.Object
- - org.silverpeas.core.importexport.control.ComponentImportExport
  - - org.silverpeas.core.importexport.control.GEDImportExport
    - - org.silverpeas.components.kmelia.importexport.KmeliaImportExport

-     public class KmeliaImportExport
      extends org.silverpeas.core.importexport.control.GEDImportExport

  Classe métier de création d'entités silverpeas utilisée par le moteur d'importExport.
  Author:
    sDevolder.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `KmeliaImportExport​(org.silverpeas.core.admin.user.model.UserDetail curentUserDetail, String currentComponentId)` | Constructeur public de la classe

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `addPublicationToTopic​(org.silverpeas.core.contribution.publication.model.PublicationPK pubPK, org.silverpeas.core.node.model.NodePK topicPK)` |
    `protected org.silverpeas.core.node.model.NodeDetail` | `addSubTopicToTopic​(org.silverpeas.core.node.model.NodeDetail nodeDetail, int topicId, org.silverpeas.core.importexport.report.MassiveReport massiveReport)` | Méthode ajoutant un thème à un thème déja existant.
    `protected org.silverpeas.core.node.model.NodePK` | `addSubTopicToTopic​(org.silverpeas.core.node.model.NodeDetail nodeDetail, int topicId, org.silverpeas.core.importexport.report.UnitReport unitReport)` | Méthode ajoutant un thème à un thème déja existant.
    `protected org.silverpeas.core.contribution.publication.model.PublicationDetail` | `createPublication​(org.silverpeas.core.contribution.publication.model.PublicationDetail pubDetail)` | Specific Kmax: Create publication with no nodeFather
    `protected String` | `createPublicationIntoTopic​(org.silverpeas.core.contribution.publication.model.PublicationDetail pubDetTemp, org.silverpeas.core.node.model.NodePK topicPK, org.silverpeas.core.admin.user.model.UserDetail userDetail)` |
    `protected org.silverpeas.core.contribution.publication.model.CompletePublication` | `getCompletePublication​(org.silverpeas.core.contribution.publication.model.PublicationPK pk)` |
    `protected KmeliaService` | `getKmeliaService()` |
    `int` | `getSilverObjectId​(String id)` | Méthode récupérant le silverObjectId d'un objet d'id id
    `void` | `publicationNotClassifiedOnPDC​(String pubId)` |
    `protected void` | `updatePublication​(org.silverpeas.core.contribution.publication.model.PublicationDetail pubDetTemp, org.silverpeas.core.contribution.publication.model.PublicationDetail pubDetailToCreate, org.silverpeas.core.admin.user.model.UserDetail userDetail)` |

    - ### Methods inherited from class org.silverpeas.core.importexport.control.GEDImportExport

      `addSubTopicToTopic, copyWysiwygImageForExport, createPublicationContent, createPublicationForMassiveImport, createPublicationForUnitImport, createTopicForUnitImport, getAliases, getAllTopicsOfPublicationInSameComponentInstance, getNodeService, getPublicationCompleteById, getPublicationCoordinates, getTopicTree, isKmax`

    - ### Methods inherited from class org.silverpeas.core.importexport.control.ComponentImportExport

      `getCurrentComponentId, getCurrentUserDetail, setCurrentComponentId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### KmeliaImportExport

          public KmeliaImportExport​(org.silverpeas.core.admin.user.model.UserDetail curentUserDetail,
                                    String currentComponentId)

      Constructeur public de la classe
      Parameters:
        `curentUserDetail` - informations sur l'utilisateur faisant appel au moteur d'importExport
        `currentComponentId` - - composant silverpeas cible

  - ### Method Detail

    - #### getKmeliaService

          protected KmeliaService getKmeliaService()

    - #### updatePublication

          protected void updatePublication​(org.silverpeas.core.contribution.publication.model.PublicationDetail pubDetTemp,
                                           org.silverpeas.core.contribution.publication.model.PublicationDetail pubDetailToCreate,
                                           org.silverpeas.core.admin.user.model.UserDetail userDetail)

      Specified by:
        `updatePublication` in class `org.silverpeas.core.importexport.control.GEDImportExport`

    - #### createPublicationIntoTopic

          protected String createPublicationIntoTopic​(org.silverpeas.core.contribution.publication.model.PublicationDetail pubDetTemp,
                                                      org.silverpeas.core.node.model.NodePK topicPK,
                                                      org.silverpeas.core.admin.user.model.UserDetail userDetail)

      Specified by:
        `createPublicationIntoTopic` in class `org.silverpeas.core.importexport.control.GEDImportExport`

    - #### addPublicationToTopic

          protected void addPublicationToTopic​(org.silverpeas.core.contribution.publication.model.PublicationPK pubPK,
                                               org.silverpeas.core.node.model.NodePK topicPK)

      Specified by:
        `addPublicationToTopic` in class `org.silverpeas.core.importexport.control.GEDImportExport`

    - #### addSubTopicToTopic

          protected org.silverpeas.core.node.model.NodePK addSubTopicToTopic​(org.silverpeas.core.node.model.NodeDetail nodeDetail,
                                                                             int topicId,
                                                                             org.silverpeas.core.importexport.report.UnitReport unitReport)
                                                                      throws org.silverpeas.core.importexport.model.ImportExportException

      Méthode ajoutant un thème à un thème déja existant. Si le thème à ajouter existe lui aussi (par exemple avec un même ID), il n'est pas modifié et la méthode ne fait rien et ne lève aucune exception.
      Specified by:
        `addSubTopicToTopic` in class `org.silverpeas.core.importexport.control.GEDImportExport`
      Parameters:
        `nodeDetail` - le détail du noeud à ajouter.
        `topicId` - l'identifiant du noeud parent, ou 0 pour désigner le noeud racine.
        `unitReport` - le rapport d'import unitaire.
      Returns:
        un objet clé primaire du nouveau thème créé ou du thème déjà existant (thème de même identifiant non modifié).
      Throws:
        `org.silverpeas.core.importexport.model.ImportExportException` - en cas d'anomalie lors de la création du noeud.

    - #### addSubTopicToTopic

          protected org.silverpeas.core.node.model.NodeDetail addSubTopicToTopic​(org.silverpeas.core.node.model.NodeDetail nodeDetail,
                                                                                 int topicId,
                                                                                 org.silverpeas.core.importexport.report.MassiveReport massiveReport)
                                                                          throws org.silverpeas.core.importexport.model.ImportExportException

      Méthode ajoutant un thème à un thème déja existant. Si le thème à ajouter existe lui aussi (par exemple avec un même ID), il n'est pas modifié et la méthode ne fait rien et ne lève aucune exception.
      Specified by:
        `addSubTopicToTopic` in class `org.silverpeas.core.importexport.control.GEDImportExport`
      Parameters:
        `nodeDetail` - l'objet node correspondant au thème à créer.
        `topicId` - l'ID du thème dans lequel créer le nouveau thème.
      Returns:
        un objet clé primaire du nouveau thème créé.
      Throws:
        `org.silverpeas.core.importexport.model.ImportExportException` - en cas d'anomalie lors de la création du noeud.

    - #### getSilverObjectId

          public int getSilverObjectId​(String id)

      Méthode récupérant le silverObjectId d'un objet d'id id
      Specified by:
        `getSilverObjectId` in class `org.silverpeas.core.importexport.control.GEDImportExport`
      Parameters:
        `id` - - id de la publication
      Returns:
        le silverObjectId de l'objet d'id id

    - #### getCompletePublication

          protected org.silverpeas.core.contribution.publication.model.CompletePublication getCompletePublication​(org.silverpeas.core.contribution.publication.model.PublicationPK pk)

      Specified by:
        `getCompletePublication` in class `org.silverpeas.core.importexport.control.GEDImportExport`

    - #### publicationNotClassifiedOnPDC

          public void publicationNotClassifiedOnPDC​(String pubId)

      Specified by:
        `publicationNotClassifiedOnPDC` in class `org.silverpeas.core.importexport.control.GEDImportExport`

    - #### createPublication

          protected org.silverpeas.core.contribution.publication.model.PublicationDetail createPublication​(org.silverpeas.core.contribution.publication.model.PublicationDetail pubDetail)

      Specific Kmax: Create publication with no nodeFather
      Specified by:
        `createPublication` in class `org.silverpeas.core.importexport.control.GEDImportExport`
      Parameters:
        `pubDetail` - publication to create
      Returns:
        pubDetail